using System.Diagnostics;

namespace WWB.SitePointPrivateMessages.Core.Infrastructure.Logging
{
    public class DebuggerLogger : ILogger
    {
        public void LogMessage(string message)
        {
            Debug.WriteLine(message);
        }

        public void LogMessage(string message, object param)
        {
            Debug.WriteLine(message, new object[]{param});
        }

        public void LogMessage(string messageFormat, object[] messageParams)
        {
            Debug.WriteLine(messageFormat, messageParams);
        }

        public void LogError(string error)
        {
            Debug.WriteLine(error);
        }

        public void LogError(string message, object param)
        {
            Debug.WriteLine(message, new object[]{param});
        }

        public void LogError(string messageFormat, object[] messageParams)
        {
            Debug.WriteLine(messageFormat, messageParams);
        }
    }
}