using NUnit.Framework;
using WWB.SitePointPrivateMessages.Core.Model.Messages;

namespace WWB.SitePointPrivateMessages.Tests.ModelTests
{
    [TestFixture]
    public class ForumUserTests
    {
        [Test]
        public void Forum_user_with_same_data_should_be_equal()
        {
            var user1 = new ForumUser() {Id = 1, Name = "Lou"};
            var user2 = new ForumUser() {Id = 1, Name = "Lou"};
            Assert.That(user1, Is.Not.SameAs(user2));
            Assert.That(user1 == user2);
        }

        [Test]
        public void Forum_users_with_different_ids_should_not_be_equal()
        {
            var user1 = new ForumUser() {Id = 1, Name = "Lou"};
            var user2 = new ForumUser() {Id = 2, Name = "Lou"};
            Assert.That(user1, Is.Not.EqualTo(user2));
        }
    }
}